// widz_probemon.c
//
//
// by FATBLOKE
//
// This sad little program monitors an area for probe requests
// and attempts to flood the AP                                   
//
// ripped a bit from	prismexplode 
//
// Function
//        Reads a wtap file and when certain conditions occur
//        call an alert script
//
// Usage 
//         prismdump wlan0 |  widz_probemon > logfile
//
//         or
//         widz_probemon < wtap dump file > logfile
//
//
//The allerts
// alert1 
//       Alert if the essid is empty
//             It the calls the Alert script and the
//              logs the next 100 packets from that source
//
//
// alert2 
//        alert if more then MAXASSO occur in
//                      less than     Maxasso time 
//             It the calls the Alert script and the
//
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <signal.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#include <asm/types.h>
#include <linux/netlink.h>
#include <netinet/in.h>

#define MAX_BUFFER_SIZE 4000	/* Size of receive buffer */
#define WTAP_PKTHDR_SIZE (sizeof(struct wtap_pkthdr)-4)
#define ROWWIDTH	32
#define SSID_SIZE	32
#define MAXASSOTIME      600  // seconds      
#define MAXASSO          10  // max associations in Maxassotime cause an alert

__u8 dummybuf[32];
__u8 dummybuf2[32];
__u8 llc[7] = { 0xaa, 0xaa, 0x03, 0x00, 0x00, 0x00, 0x08 };

struct wtap_pkthdr
{
  struct timeval ts;
  __u32 caplen;
  __u32 len;
  int pkt_encap;
};

typedef struct
{
  __u16 frame_control __attribute__ ((packed));
  __u16 duration_id __attribute__ ((packed));
  __u8 mac1[6] __attribute__ ((packed));
  __u8 mac2[6] __attribute__ ((packed));
  __u8 mac3[6] __attribute__ ((packed));
  __u16 sequence __attribute__ ((packed));
  __u8 mac4[6] __attribute__ ((packed));
}
wlan_hdr_t;

typedef struct
{
  unsigned char version:2;
  unsigned char type:2;
  unsigned char subtype:4;
  unsigned char toDS:1;
  unsigned char fromDS:1;
  unsigned char morefrag:1;
  unsigned char retry:1;
  unsigned char pwr:1;
  unsigned char moredata:1;
  unsigned char wep:1;
  unsigned char rsvd:1;
}
frame_control_t;

/*
 *	for dumping the frame in ascii
 */
char *
asciidump (__u8 * x, int y)
{
  int i = -1;
  while (++i < y)
    if isprint
      (x[i]) sprintf (&dummybuf2[i], "%c", x[i]);
    else
      sprintf (&dummybuf2[i], ".");
  return (dummybuf2);
}

/*
 *	for dumping the frame in hex
 */
char *
hexdump (__u8 * x, int y)
{
  int i = -1;
  while (++i < y)
    sprintf (&dummybuf[(i * 2)], "%02x", x[i]);
  return (dummybuf);
}

/*
 *	attempts to determine if this data buffer is wep encrypted
 *  by analyzing the distribution of each byte.  encrypted data
 *  looks like noise and unencrypted data does not.  this is
 *  however, an approximation algorithm, and therefore not 100%
 *  reliable.
 */
int detect_wep (__u8 *buf, int len)
{
	__u8 distcount[0xff], c, max=0;
	float	dist;

	bzero(distcount,0xff);
	/*
	 * count incident of each byte
	 */
	 for (c=0;c<len;c++)
		 distcount[buf[c]]++;
	/*
	 * find maximum incidence
	 */
	 for (c=0;c<0xff;c++)
		if (max < distcount[c])
			max=distcount[c];
	dist = max;
	dist /= len;
	return ( dist < 0.1 ? 1 : 0 );
}


  unsigned char msgbuf[MAX_BUFFER_SIZE];
  int nullssid;
char  macaddress_1[13];
char  macaddress_2[13];
char  macaddress_3[13];
char  macaddress_4[13];
char  trackmac[13];
char  buffer[90];
char  packet_type[13];
char  packet_subtype[13];

  char *
getssid(char *p)
		{
			int i;
   nullssid=0;
			i=(msgbuf[37] & 0xff)+1;
			if ( i    < 2            )
			{
   nullssid=1;
			sprintf(p,"%s", "        ");
			}
			else
			snprintf(p,i ,"%s",&msgbuf[38]);
			return p;
		}
get_packettype( int type,int subtype)
{

  char *typestring[4] = { "Management", "Control", "Data", "Reserved" };

/*
 * subtype lookup vectors
 */
  char *mgmtsubtypestring[16] =
    { "Association Request", "Association Response",
    "ReAssociation Request", "Reassociation Response", "Probe Request",
    "Probe Response", "Reserved", "Reserved", "Beacon", "ATIM",
    "Disassociation", "Authentication", "Deauthentication", "Reserved",
    "Reserved", "Reserved"
  };

  char *ctrlsubtypestring[16] =
    { "Reserved", "Reserved", "Reserved", "Reserved",
    "Reserved", "Reserved", "Reserved", "Reserved", "Reserved", "Reserved",
    "PS-Poll", "RTS", "CTS", "ACK", "CF End", "CF End + CF Ack"
  };

  char *datasubtypestring[16] = { "Data", "Data + CF Ack", "Data + CF Poll",
    "Data + CF Ack + CF Poll", "NULL Function", "CF Ack (no data)",
    "CF Poll (no data)", "CF Ack + CF Poll (no data)", "Reserved",
    "Reserved", "Reserved", "Reserved", "Reserved", "Reserved",
    "Reserved", "Reserved"
  };

	sprintf (packet_type,"%s",typestring[type]);
		switch (type)
		{
		case 0:
			sprintf (packet_subtype,"%s",mgmtsubtypestring[subtype]);
			break;
		case 1:
			sprintf (packet_subtype,"%s",ctrlsubtypestring[subtype]);
			break;
		case 2:
			sprintf (packet_subtype,"%s",datasubtypestring[subtype]);
			break;
		case 3:
			sprintf (packet_subtype,"Reserved%u",subtype);
			break;
		}
			
}
		print_packet(int n, int caplen , char *ssid)
{
		printf ("\n\n packet_number:%u ",n);
		printf (" packet_length:%u ",caplen);
		printf (" frame_control:type:%s ",packet_type);
		printf (" subtype: %s ",packet_subtype);
			
		printf (" mac-address-1:0x%s ", 
				macaddress_1);
		printf (" mac-address-2:0x%s",
				macaddress_2);
		printf (" mac-address-3:0x%s ",
				macaddress_3);
		printf (" mac-address-4:0x%s ",
				macaddress_4);
			printf (" SSID:%s",ssid);
}
		/*
		 **/
main (int argc, char **argv)
{
  int caplen, counter, temp, showascii = 0, showraw = 0, summary=0, filtman = 0, n = 0, status = 0;
  wlan_hdr_t *packet_hdr;
  struct wtap_pkthdr packet_hdr_info;
  __u8 ssid[32]="";
  frame_control_t *fc;

  time_t  otime = 999999999;
  int onlyman  = 0;
  int nobeacon  = 0;
  int naughty_packets=0;
char pritty[2];  
int   assoc_counter =  0;

	/*
	 *	read in and discard wtap file header info
	 */
	if (1!=fread(msgbuf,24,1,stdin))
	{
		printf ("could not read the file header\n");
		perror("fread");
		return(-1);
	}
	while (1)
	{
		memset (msgbuf, 0, MAX_BUFFER_SIZE);
		memset (ssid, 0, SSID_SIZE);
		n++;
		/*
		 *	read wtap packet header
		 */
		if (1 != fread(&packet_hdr_info,WTAP_PKTHDR_SIZE,1,stdin))
		{
			fprintf(stderr,"could not read wiretap frame header. aborting...\n");
			perror("fread");
			status=-1;
			break;
		}
		/*
		 *	quick check for bogus headers
		 */
		if (packet_hdr_info.len != packet_hdr_info.caplen)
		{
			fprintf(stderr,"prismdump wiretap header impossibility: caplen!=len (%10u!=%u)\n",
				packet_hdr_info.caplen,packet_hdr_info.len);
			status=-1;
			break;
		}
		/*
		 *	read the 802.11 frame
		 */
		caplen=packet_hdr_info.caplen;
		if (1 != fread(msgbuf,caplen,1,stdin))
		{
			fprintf(stderr,"couldn't read 802.11 frame header! aborting...\n");
			perror("read");
			status=-1;
			break;
		}
		/*
		 *	cast the frame into the 802.11 structs
		 */
		packet_hdr = (wlan_hdr_t *) msgbuf;
		fc=(frame_control_t *)&packet_hdr->frame_control;
		/*
		 *
		 */
                 if (  otime == 999999999)
                       otime = packet_hdr_info.ts.tv_sec;
		sprintf (macaddress_1,"%s", hexdump((unsigned char *)&packet_hdr->mac1,6));
		sprintf (macaddress_2,"%s", hexdump((unsigned char *)&packet_hdr->mac2,6));
		sprintf (macaddress_3,"%s", hexdump((unsigned char *)&packet_hdr->mac3,6));
		sprintf (macaddress_4,"%s", hexdump((unsigned char *)&packet_hdr->mac4,6));
		get_packettype(fc->type,fc->subtype);
		getssid(ssid);
		// after a null probe log the next 100 packets from that source
		if ( (  strcmp(trackmac, macaddress_1) == 0 )  || 
		          (  strcmp(trackmac, macaddress_2) == 0 )  || 
		          (  strcmp(trackmac, macaddress_3) == 0 )  || 
		          (  strcmp(trackmac, macaddress_4) == 0 )  )
		     {
		     print_packet(n, caplen ,ssid); 
		     naughty_packets++;
		     if ( naughty_packets  > 100 )
		         {
		          strcpy(trackmac, "xxxxxxxxxxxx");
		          naughty_packets=0;
			 }
		     }
		// alerts
		if (fc->type == 0) 
		{
		// alert1 
		//       Alert if the essid is empty
			if ( fc->subtype == 4)  //  probe  packets
			{
			if ( nullssid )  //  probe  packets
			   {
			   sprintf (buffer," Alert 'Null Probe %s %s %s %s %s'",
					   ssid, macaddress_1, macaddress_2, macaddress_3, macaddress_4);
			   system (buffer);
		           print_packet(n, caplen ,ssid); 
		           strcpy(trackmac, macaddress_1);
			   }
				
			}
		// alert2 
		//        alert if more then MAXASSO occur in
		//                           Maxasso time 
			if ( fc->subtype == 0)  //  association packet
			{
			if ( assoc_counter == 0  )  //  only first time round
                           otime = packet_hdr_info.ts.tv_sec;
			   
			assoc_counter++;
			// if in MAXASSO number of association request
			//   less the MAXASSOTIME seconds have transpired
			//   you are being flooded
			//
			if ( assoc_counter > MAXASSO   )  //  probe  packets
			   {
                           otime = packet_hdr_info.ts.tv_sec;
			   assoc_counter =  1;
			   
			   if ( difftime( packet_hdr_info.ts.tv_sec, otime) < MAXASSOTIME )           
			      {
			      sprintf (buffer, " Alert 'association flood %s %s %s %s %s'",
					   ssid, macaddress_1, macaddress_2, macaddress_3, macaddress_4);
			      system (buffer);
			      }
			   }
			}
		}
		if (fc->wep)
			{
			printf (" IV:%s ", hexdump((unsigned char *)&msgbuf[24],3));
			}
		/*
 		 *	since the smc driver clears the wep bit (I assume so that
		 *	sniffed packet will be passed up), we cant use it to recognize
		 *	WEP frames.  instead, i try to recognize an unencrypted link
		 *	layer control header in the expected location.  a failure
		 *	means the packet is (probably) WEP.
		 */
	        if ((fc->type==2) && (detect_wep(&msgbuf[24],(caplen-24))))
		 	fc->wep=1;
        	if ((packet_hdr->frame_control & 0xff00) >> 8)
			printf ("\t\t\tflags: %s%s%s%s%s%s%s%s",
			( fc->toDS ? "toDS " : ""),
			( fc->fromDS ? "fromDS " : ""),
			( fc->morefrag ? "morefrag " : ""), ( fc->retry ? "retry " : ""),
			( fc->pwr ? "pwr_mngmnt " : ""),
			( fc->moredata ? "moredata " : ""),
			( fc->wep ? "WEP " : ""),
			( fc->rsvd ? "reserved " : "")
			);
		printf ("\n");
	}
	fprintf (stderr,"%d packets analyzed\n",n);
	fflush(stdout);
	fflush(stderr);
	return(status);
}
